 /* ------------ ibmpc.c ------------ */

/*
  low-level functions addressing BIOS & PC Hardware*/


/*#pragma inline*/
#include "C:\borlandc\include\dos.h"
static union REGS rg;
#define UP 1
#define DN 0
#define CGA
int ReadAbs(int D,int *CP);
void writkey(int scn,int asc);
 void dpixal(int x,int y,unsigned int c);
 void   scroll_srn(int dir,int ln);
/* ------------ position the cursor ------------ */
void cursor(int x, int y)
{
   rg.x.ax = 0x0200;
   rg.x.bx = 0;
   rg.x.dx = ((y << 8) & 0xff00) + x;
   int86(16, &rg, &rg);
}

/* ------------ return the cursor position ------------ */
void curr_cursor(int *x, int *y)
{
   rg.x.ax = 0x0300;
   rg.x.bx = 0;
   int86(16, &rg, &rg);
   *x = rg.h.dl;
   *y = rg.h.dh;
}

/* ------------ set cursor type ------------ */
void set_cursor_type(int t)
{
   rg.x.ax = 0x0100;
   rg.x.bx = 0;
   rg.x.cx = t;
   int86(16, &rg, &rg);
}
char attrib = 7;

/* ------------ clear the screen ------------*/
void clear_screen()
{
      cursor(0, 0);
      rg.h.al =0;
      rg.h.ah = 9;
      rg.x.bx = attrib;
      rg.x.cx = 2000;
      int86(16, &rg, &rg);
}

/* ------------- return the video mode ------------ */
int vmode()
{
    rg.h.ah = 15;
    int86(16, &rg, &rg);
    return rg.h.al;
}

/* ------------ test for scroll lock ------------*/
int scroll_lock()
{
    rg.x.ax = 0x0200;
    int86(0x16, &rg, &rg);
    return rg.h.al & 0x10;
}
void (*helpfunc)();
int helpkey = 0;
int helping = 0;
/* ------------ get a keyboard character ------------- */
int get_char()
{
    int c;

    while (1)     {
	rg.h.ah = 1;
	int86(0x16, &rg, &rg);
	if (rg.x.flags & 0x40)    {
	    int86(0x28, &rg, &rg);
	    continue;
	}
	rg.h.ah = 0;
	int86(0x16, &rg, &rg);
	if (rg.h.al == 0)
	    c = rg.h.ah | 128;
	else
	    c = rg.h.al;
      /* if (c == helpkey && helpfunc)       {
	    if (!helping)     {
		 helping = 1;
		 (*helpfunc)();
		 helping = 0;
		 continue;
	    }
	   }
	if(c==221) {
		rev();
		continue;} */
    break;
  }
  return c;
}

/*-------------SCREEN SCROLL UP--------------------*/
void   scroll_srn(int dir,int ln)
{
  rg.h.ah = dir == UP ? 6 : 7;
  rg.h.al = 2;
  rg.h.bh = 0;
  rg.h.ch = ln*2;
  rg.h.cl = 0;
  rg.h.dh = 23;
  rg.h.dl = 79;
  int86(16,&rg,&rg);
};

void writkey(int scn,int asc)
{
rg.h.ah=05;
rg.h.ch=scn;
rg.h.cl=asc;
int86(22,&rg,&rg);
}
int Absread(int D,int n, int s, char  *Buf)
{
static union REGS rg;
struct SREGS sr;
int r;
struct
	{
	unsigned long SN;
	unsigned int C;
	char * BP;
	} CP;
CP.SN=s;
CP.C=n;
CP.BP =  Buf;
rg.h.al = D;
rg.x.cx =-1;
rg.x.bx=FP_OFF(&CP);
sr.ds=FP_SEG(&CP);
r=int86x(0x25,&rg,&rg,&sr);
rg.x.cflag*=-1;
return rg.x.cflag;
}
