 #include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloc.h>
#include <graphics.h>
#include "twindow.h"
#include "keys.h"
#define MAXHELPS 30
#define HBG WHITE
#define HFG BLACK
#define HINT DIM
#define TRUE 1
#define FALSE 0
void ghelp(int cx,int cy,int ht,int wt);
void rev();
static struct helps {
       char hname [9];
       int h,w;
       long hptr;
       } hps [MAXHELPS+1];
static int hp = 0;
static int ch = 0;
static int hx,hy;
FILE *helpfp = NULL;
long ftell();
char *fgets();
void help();
char helpname[64];
void getline(char *lineh);
void load_help(char *hn)
{
   extern void (*helpfunc)();
   extern int helpkey;
   char lineh [80];
   if(strcmp(helpname, hn)==0)
   return;
   helpfunc = help;
   helpkey = F1;
   hp=0;
   strcpy(helpname,hn);
   if((helpfp = fopen(helpname,"r")) == NULL)
   return;
   getline(lineh);
   while(1) {
     if(hp==MAXHELPS)
     break;
     if(strncmp(lineh,"<end>",5)==0)
     break;
     if(*lineh != '<')
	  continue;
	  hps[hp].h=3;
	  hps[hp].w =18;
	  strncpy(hps[hp].hname,lineh+1,8);
	  hps[hp].hptr = ftell(helpfp);
	  getline(lineh);
	  while(*lineh != '<') {
	       hps[hp].h++;
	       hps[hp].w = max(hps[hp].w,strlen(lineh)+2);
	       getline(lineh);
	       }
	  hp++;
     }
   }

   static void getline(char *lineh)
   {
	if(fgets(lineh,80,helpfp)==NULL)
	strcpy(lineh,"<end>");
   }
   void set_help(char *s, int x, int y)
   {
    for(ch=0; ch< hp; ch++)
       if(strncmp(s,hps[ch].hname,8)==0)
	 break;
	 hx =x;
	 hy= y;
    }
void help()
 {
  char ln[80];
  int i,xx,yy;
  WINDOW *wnd;
  extern int helpkey;
  if(vmode()==6) { ghelp(hx*8,hy*8,hps[ch].h*8,hps[ch].w*8); return;}
  if (hp && ch != hp) {
    curr_cursor(&xx,&yy);
    cursor(0,25);
    wnd = establish_window(hx,hy,hps[ch].h,hps[ch].w);
    set_title(wnd,"* * HELP * *");
    set_colors(wnd,ALL,HBG,HFG,HINT);
    display_window(wnd);
    fseek(helpfp,hps[ch].hptr,0);
    for(i=0;i<hps[ch].h-3;i++) {
      getline(ln);
      wprintf(wnd,ln);
      }
      wprintf(wnd, " Press any Key to return");
	      get_char();
      delete_window(wnd);
      cursor(xx,yy);
    }
  }
void ghelp(int cx,int cy,int ht,int wt)
	{
	void far *buffer;
	int i;
	char ln[80];
	buffer = farmalloc(imagesize(cx,cy,cx+wt,cy+ht));
	getimage(cx,cy,cx+wt,cy+ht,buffer);
	drawbox(cx,cy,ht,wt,1,0,1);
	setlinestyle(0,0,3);
	rectangle(cx+5,cy+3,cx+wt-5,cy+ht-3);
	cursor(hx+wt/16-8,hy);
	printf("* * * HELP * * *");
	fseek(helpfp,hps[ch].hptr,0);
	cursor(hx+1,hy+1);
	for(i=0;i<hps[ch].h-3;i++) {
	getline(ln);
	printf(ln);
	cursor(hx+1,hy+i+1);
	 }
	printf(" \n");
	cursor(hx+wt/16-13,hy+i+2);
	printf( "* PRESS ANY KEY TO RETURN *");
	setwritemode(1);
	for(i=1;i<ht;i+=3) line(cx,cy+i,cx+wt,cy+i);
	get_char();
	putimage(cx,cy,buffer,0);
	setlinestyle(0,0,1);
	farfree(buffer);
    }
void rev()
    {
    int i;
    setcolor(1);
    setwritemode(1);
    for(i=0;i<640;i++) line(i,0,i,199);
    }